import { DynamoAttributeValue } from "@aws-cdk/aws-stepfunctions-tasks";
import { DynamoAttributeName } from "./attribute-name";
import { Placeholder } from "./placeholder";
export interface ExpressionAggregate {
    /**
     * Built expression that contains calculated placeholders.
     */
    readonly expression: string;
    /**
     * attribute values that used to substitute expression's placeholders by DynamoDB.
     */
    readonly expressionAttributeValues: {
        [key: string]: DynamoAttributeValue;
    };
    /**
     * attribute names that used to substitute expression's placeholders by DynamoDB.
     */
    readonly expressionAttributeNames: {
        [key: string]: DynamoAttributeName;
    };
}
/**
 * Builds an expression and expression attribute values from template string.
 */
export declare const dynamoExpr: (literals: TemplateStringsArray, ...placeholers: Placeholder[]) => ExpressionAggregate;
