"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.dynamoExpr = void 0;
const counter_1 = require("./counter");
const placeholder_1 = require("./placeholder");
/**
 * Builds an expression and expression attribute values from template string.
 */
exports.dynamoExpr = (literals, ...placeholers) => {
    let expression = "";
    const expressionAttributeValues = {};
    const expressionAttributeNames = {};
    placeholers.forEach((pv, idx) => {
        if (placeholder_1.isAttrName(pv)) {
            const { value } = counter_1.namesRefCounter.next();
            const placeholder = `#${value}`;
            expression += literals[idx];
            expression += placeholder;
            expressionAttributeNames[placeholder] = pv;
        }
        else {
            const { value } = counter_1.refCounter.next();
            const ref = `:v${value}`;
            expression += literals[idx];
            expression += ref;
            expressionAttributeValues[ref] = pv;
        }
    });
    expression += literals[literals.length - 1];
    return { expression, expressionAttributeValues, expressionAttributeNames };
};
